<?php
// Inspired from yii builtin Captcha
// @author totoloco at gmail
// @site http://ushcompu.com.ar

Yii::import('ext.tryiimath.ETryiimathAction');
require_once(dirname(__FILE__).'/trymath/trymath_class.php');

class ETryiimath extends CWidget {
  public $trymathAction='tryiimath';
  public $showRefreshButton=true;
  public $clickableImage=false;
  public $loadingHtml='...';
  public $buttonLabel;
  public $buttonType='link';
  public $divOptions=array('style'=>'white-space:pre;font-family:monospace;');
  public $buttonOptions=array();

  public function run()
  {
    $this->renderAscii();
    $this->registerClientScript();
  }

  protected function renderAscii() {
    if(isset($this->divOptions['id']))
      $id=$this->divOptions['id'];
    else
      $id=$this->divOptions['id']=$this->getId();
    $url=$this->getController()->createAbsoluteUrl($this->trymathAction);
    $trymath = Yii::app()->getController()->createAction($this->trymathAction);
    $div = '<div';
    foreach ($this->divOptions as $key=>$opt) {
      $div .= ' '.$key.'='.$opt;
    }
    echo $div.'>';
    $trymath->run();
    echo '</div>';
    
  }

  public function registerClientScript() {
    $cs=Yii::app()->clientScript;
    $id=$this->divOptions['id'];
    $url=$this->getController()->createUrl($this->trymathAction,array(ETryiimathAction::REFRESH_GET_VAR=>true));

    if($this->showRefreshButton) {
      $cs->registerScript('Yii.ETryiimath#'.$id,'dummy');
      $label=$this->buttonLabel===null?Yii::t('yii','Get a new math'):$this->buttonLabel;
      $button=$this->buttonType==='button'?'ajaxButton':'ajaxLink';
      $html=CHtml::$button($label,$url,array(
          'beforeSend'=>'js:function(){jQuery("#'.$id.'").html("'.$this->loadingHtml.'");}',
          'success'=>'js:function(html){jQuery("#'.$id.'").html(html)}'
        ),$this->buttonOptions);
      $js="jQuery('#$id').after(\"".CJavaScript::quote($html).'");';
      $cs->registerScript('Yii.ETryiimath#'.$id,$js);
    }

    if($this->clickableImage) {
      $js="jQuery('#$id').click(function(){"
        .CHtml::ajax(array(
          'url'=>$url,
          'beforeSend'=>'js:function(){jQuery("#'.$id.'").html("'.$this->loadingHtml.'");}',
          'success'=>"js:function(html){jQuery('#$id').html(html)}",
        )).'});';
      $cs->registerScript('Yii.ETryiimath#2'.$id,$js);
    }
  }
}
